;BTS Install Script
;Written by phungus420, NikNaks, Jean Elcard, and Emperor Fool

;--------------------------------
;Include Modern UI

  !include "MUI2.nsh"
  !include "LogicLib.nsh"
  !include "FileSearch.nsi"

;--------------------------------
  ;Constants
  ;These are the variables you need to define for your mod

  !define NAME "Dune Wars - Revival" ;Full Name of Mod
  !define VERSION "1.0.1" ;Mod Version Number

  !define MOD_LOC "DuneWars Revival" ;Name of Mod Folder
  !define SHORT_NAME "DuneWars Revival" ;Shorthand/nick of your mod

  !define MYBTSDIR "C:\Program Files (x86)\Steam\SteamApps\common\Sid Meier's Civilization IV Beyond the Sword\Beyond the Sword" ;Path where your Beyond the Sword .exe is
  !define MYCLSDIR "${MYBTSDIR}\Mods\${MOD_LOC}" ;Path where your mod is (Leave ${MOD_LOC} on the end of the path)
  !define MYFILESDIR "C:\Users\Iain\Documents\My Games\beyond the sword" ;Your BtS My Documents directory
 
  !define CIV_EXE_FILE "Civ4BeyondSword.exe"
  !define CIV_INI_FILE "CivilizationIV.ini"
  
  !define RAW_ICON "DuneWars.ico"	;place your icon in your mod folder change someicon to the icon's name
  
  !define URL "http://forums.civfanatics.com/forumdisplay.php?f=358"
  
  ;Add Ons
  ;If you would like to change the hover text for you add ons, search for LangString DESC_Section
  ;!define SETTINGS_FOLDER "UserSettings"
 
  ;You should not need to change anything below this line
  ;You may want to adjust the hover text for your add ons, or remove the second add on entries.  See above.
  
  !define ICON "${MYCLSDIR}\${RAW_ICON}" 
  !define MUI_ICON "${ICON}"
  
  ;Registry Constants
  !define MACHINE_REG_ROOT "HKLM"
  !define USER_REG_ROOT "HKCU"
  !define LONG_HKLM "HKEY_LOCAL_MACHINE"
  !define LONG_HKCU "HKEY_CURRENT_USER"
  !define FIRAXIS_REG_KEY "Software\Firaxis Games"
  !define BTS "Beyond the Sword"
  !define BTSREG_STANDARD "Sid Meier's Civilization 4 - ${BTS}"
  !define BTS_SHORT "BtS"
  !define BTS_VERSION "3.19"
  !define COMPLETE_REG "Sid Meier's Civilization 4 Complete"
  !define GOLD_REG "Sid Meier's Civilization 4 Gold"
  !define GLOBAL_DEFINES "Assets\XML\GlobalDefines.xml"
  !define GD_VERSION "<iDefineIntVal>319</iDefineIntVal>"
  
  ;CurrentVersion variable values
  !define UNKNOWN "unkown"
  !define NULL "null"

;--------------------------------
;General

  ;Name and file

  Name "${NAME}"
  !ifdef ICON
  Icon "${ICON}"
  !endif
  OutFile "${NAME} v${VERSION} Setup.exe" 

  ;Default installation folder
  InstallDir ""

  ;Request application privileges for Windows Vista
  RequestExecutionLevel admin

;--------------------------------
;Custom Varaiables

  Var INSTDIR1 ; Mods
  Var StartMenuFolder
  Var CivRootDir
  Var CurrentVersion
  Var WelcomePageText
  Var DirectoryPageText
  
  Var CurrentPage ; important for directory verification
  
;-------------------------------------------------------
  ;Search Registry and Look for BtS install directory
  

  
  Function findINSTDIR1

	Push $0
	#Search for a valid BtS registry key, and get the Install Folder
	
	#look for standard Civ4:BTS
	ReadRegStr $0 ${MACHINE_REG_ROOT} "${FIRAXIS_REG_KEY}\${BTSREG_STANDARD}" 'INSTALLDIR'
	${If} ${FileExists} $0
		StrCpy $INSTDIR1 $0
		${If} ${FileExists} "$INSTDIR1\${GLOBAL_DEFINES}"
			Push $INSTDIR1\${GLOBAL_DEFINES}
			Push ${GD_VERSION}
			Call FileSearch
			Pop $0
			Pop $1
			${If} $0 > "0"
				StrCpy $CurrentVersion "true"
				Goto done
			${Else}
				StrCpy $CurrentVersion "false"
				Goto done
			${EndIf}
		${Else}
			StrCpy $CurrentVersion "${UNKNOWN}"
			Goto done
		${EndIf}
	${EndIf}

	
	# Civ4 Complete
	ReadRegStr $0 ${MACHINE_REG_ROOT} "${FIRAXIS_REG_KEY}\${COMPLETE_REG}" 'INSTALLDIR'
	${If} ${FileExists} $0
		StrCpy $0 "$0\${BTS}"
		${If} ${FileExists} $0
			StrCpy $INSTDIR1 $0
			${If} ${FileExists} "$INSTDIR1\${GLOBAL_DEFINES}"
				Push $INSTDIR1\${GLOBAL_DEFINES}
				Push ${GD_VERSION}
				Call FileSearch
				Pop $0
				Pop $1
				${If} $0 > "0"
					StrCpy $CurrentVersion "true"
					Goto done
				${Else}
					StrCpy $CurrentVersion "false"
					Goto done
				${EndIf}
			${Else}
				StrCpy $CurrentVersion "${UNKNOWN}"
				Goto done
			${EndIf}
		${EndIf}
	${EndIf}
	
	# Civ4 Gold
	ReadRegStr $0 ${MACHINE_REG_ROOT} "${FIRAXIS_REG_KEY}\${GOLD_REG}" 'INSTALLDIR'
	${If} ${FileExists} $0
		StrCpy $0 "$0\${BTS}"
		${If} ${FileExists} $0
			StrCpy $INSTDIR1 $0
			${If} ${FileExists} "$INSTDIR1\${GLOBAL_DEFINES}"
				Push $INSTDIR1\${GLOBAL_DEFINES}
				Push ${GD_VERSION}
				Call FileSearch
				Pop $0
				Pop $1
				${If} $0 > "0"
					StrCpy $CurrentVersion "true"
					Goto done
				${Else}
					StrCpy $CurrentVersion "false"
					Goto done
				${EndIf}
			${Else}
				StrCpy $CurrentVersion "${UNKNOWN}"
				Goto done
			${EndIf}
		${EndIf}
	${EndIf}
	
  ;No BtS registry found, give CurrentVersion a non 1,0 value
  StrCpy $CurrentVersion "${NULL}"
  Goto done

  done:
	Pop $0

  FunctionEnd

  ;Look for valid BtS folder in My Documents Path
  Function findCivRootDir

	Push $0	
	# locate the Civ4:BTS INI folder
	StrCpy $0 "$DOCUMENTS\My Games\${BTS}"
	${If} ${FileExists} "$0\${CIV_INI_FILE}"
		StrCpy $CivRootDir $0
	${Else}
		StrCpy $CivRootDir "$DOCUMENTS\My Games"
	${EndIf}
	Pop $0

  FunctionEnd
  
  ;Depending on Registry checks, set welcome text
  Function setWelcomePageText

    Call findINSTDIR1

	${If} $CurrentVersion == "true"
		StrCpy $WelcomePageText "This wizard will guide you through the installation of \
		${NAME} version ${VERSION}.  $\n$\n\
		Please ensure that Civilization 4 is not running while installing, \
		otherwise the installation may not work as expected.  $\n$\n\
		Click $\"Next$\" to continue."
	${ElseIf} $CurrentVersion == "${UNKNOWN}"
		StrCpy $WelcomePageText "This wizard will guide you through the installation of \
		${NAME} version ${VERSION}.  $\n$\n\
		Autodetection found a Civilization IV registry, \
		but could not find a Global Defines file in the  ${BTS_SHORT} directory.  \
		Setup could not verify the ${BTS_SHORT} version or the install path.  \
		${NAME} requires that ${BTS_SHORT} be updated to version ${BTS_VERSION}, \
		attempting to launch ${SHORT_NAME} on a non updated version \
		will result in an immediate crash to desktop.  $\n$\n\
		The ${BTS_SHORT} ${BTS_VERSION} patch can be downloaded easily from the downloads section \
		of the civfanatics website (www.civfanatics.com).  \
		The patch is also simple to find by using Google, or other internet search engine.  $\n$\n\
		Click $\"Next$\" to continue"
	${ElseIf} $CurrentVersion == "${NULL}"
		StrCpy $WelcomePageText "This wizard will guide you through the installation of \
		${NAME} version ${VERSION}.  $\n$\n\
		Autodetection has completely failed to locate a valid Civilization 4 registry; \
		so you will need to manually set some items that the installer would normally handle automatically.  \
		${NAME} requires that ${BTS} be updated to version ${BTS_VERSION}, \
		attempting to launch ${SHORT_NAME} on a non updated version \
		will result in an immediate crash to desktop.  \
		The ${BTS_SHORT} ${BTS_VERSION} patch can be downloaded easily from the downloads section \
		of the civfanatics website (www.civfanatics.com).  \
		The patch is also simple to find by using Google, or other internet search engine.  $\n$\n\
		Click $\"Next$\" to continue"
	${Else}
		StrCpy $WelcomePageText "An unexpected error has occured!!!"
	${EndIf}
	


  FunctionEnd
  
  ;Depending on Registry checks, set instructions
  Function setDirectoryPageText

    Call findINSTDIR1

	${If} $CurrentVersion == "true"
		StrCpy $DirectoryPageText "Autodetection successfully located a ${BTS} registry, \
		and a Global Defines entry indictation ${BTS} has been properly updated to ${BTS_VERSION}.  \
		Setup has used the registry key to automatically set the installation path for ${MOD_LOC}, \
		and will install ${NAME} in the Mods folder of the folder below. $\n$\n\
		Simply click $\"Next$\" to begin installation."
	${ElseIf} $CurrentVersion == "${UNKNOWN}"
		StrCpy $DirectoryPageText "Setup will install ${MOD_LOC} in the mods folder of the directory below.  $\n\
		Autodetection could not locate the ${BTS_SHORT} Global Defines file.  \
		To verify the install path is correct, \
		a ${BTS_SHORT}.exe must be present in the install directory.  \
		${NAME} requires that ${BTS_SHORT} be updated to version ${BTS_VERSION}, \
		attempting to launch ${SHORT_NAME} on a non updated version \
		will result in an immediate crash to desktop.  $\n$\n\
		Click $\"Next$\" to begin installation."
	${ElseIf} $CurrentVersion == "${NULL}"
		StrCpy $DirectoryPageText "Autodetection failed to detect a valid Civilization 4 registry, \
		so you will need to manually set the install path in the line below.  \
		Setup will install ${NAME} in the Mods folder of the directory you set.  \
		To verify that the install path is correct, \
		Setup will also check for the existence of the ${BTS_SHORT}.exe.  \
		If Setup does not detect the ${BTS_SHORT}.exe in your selected install path, \
		it will not allow installation to continue.  \
		${NAME} requires that ${BTS_SHORT} be updated to version ${BTS_VERSION}, \
		attempting to launch ${SHORT_NAME} on a non updated version \
		will result in an immediate crash to desktop.  \
		Click $\"Next$\" to begin installation."
	${Else}
		StrCpy $DirectoryPageText "An unexpected error has occured!!!"
	${EndIf}

  FunctionEnd

;--------------------------------

  ;Initialize Installer
  
  Function .onInit

    Call findINSTDIR1
	Call findCivRootDir
	Call setDirectoryPageText
	Call setWelcomePageText
    StrCpy $INSTDIR "$INSTDIR1"

	${If} $CurrentVersion == "false" ;Registry Check succeded, but BtS is not updated to the current BtS version
	
		;Cancel installation and tell user to update BtS and run the installer again
		MessageBox MB_OKCANCEL|MB_ICONEXCLAMATION \
		"The installer has detected a ${BTS} registry key; \
		however it has also found that ${BTS} has not been updated to version ${BTS_VERSION}.  $\n$\n\
		The ${BTS_SHORT} ${BTS_VERSION} patch can be downloaded directly from:  $\n\
		http://www.firaxis.com/downloads/Patch/Civ4BeyondTheSwordPatch3.19.exe  $\n\
		The patch is also easy to find by simply searching with Google, or other internet search engine.  $\n$\n\
		${NAME} requires that ${BTS} be updated to the current official version of ${BTS_VERSION}.  \
		Please update your copy of ${BTS_SHORT} to ${BTS_VERSION}, and then run this installer again.  $\n$\n\
		The installation of ${SHORT_NAME} will now abort." \
		IDOK quit
		Abort
		
		quit:
		Abort
	
	${Else}
		;BtS is either updated to the current version, or the registry check failed
	;Check to see if the mod is already installed
    ReadRegStr $R0 ${MACHINE_REG_ROOT} \
    "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MOD_LOC}" \
    "UninstallString"
    StrCmp $R0 "" done

    MessageBox MB_OKCANCEL|MB_ICONEXCLAMATION \
    "${NAME} is already installed. $\n$\nDo you wish to uninstall?" \
    IDOK uninst
    Abort

    ;Run the uninstaller if you find a Registry Key for the mod
    uninst:
    ClearErrors
    ExecWait '"$INSTDIR\Mods\${MOD_LOC}\Uninstall.exe" _?=$INSTDIR'
	Delete "$INSTDIR\Mods\${MOD_LOC}\Uninstall.exe"
	${EndIf}

    done:

  FunctionEnd

;--------------------------------
;Interface Settings

  !define MUI_ABORTWARNING
  !define MUI_UNABORTWARNING
  !define MUI_FINISHPAGE_NOAUTOCLOSE
  !define MUI_UNFINISHPAGE_NOAUTOCLOSE
  !define MUI_HEADERIMAGE

  ShowInstDetails show
  ShowUninstDetails show

;--------------------------------
;Pages

  !define MUI_CUSTOMFUNCTION_GUIINIT myOnGUIInit

  ; INSTALLER PAGES:

  !define MUI_WELCOMEPAGE_TITLE "Welcome to the Setup of ${SHORT_NAME} v${VERSION}"
  !define MUI_WELCOMEPAGE_TEXT $WelcomePageText
	
  !insertmacro MUI_PAGE_WELCOME

  !define MUI_COMPONENTSPAGE_SMALLDESC
  !insertmacro MUI_PAGE_COMPONENTS

  !define MUI_DIRECTORYPAGE_VARIABLE $INSTDIR1
  !define MUI_PAGE_CUSTOMFUNCTION_PRE onInitDirectoryPage1
  !define MUI_PAGE_HEADER_TEXT "${SHORT_NAME} v${VERSION}"
  !define MUI_PAGE_HEADER_SUBTEXT "Please locate your $\"${BTS}$\" folder"
  !define MUI_DIRECTORYPAGE_TEXT_TOP $DirectoryPageText
  !define MUI_DIRECTORYPAGE_TEXT_DESTINATION "Your $\"${BTS}$\" folder:"
  !insertmacro MUI_PAGE_DIRECTORY
  
  ;Setup all the Start Menu Shortcut selection stuff
  Page custom StartMenuShortcut
  !define MUI_PAGE_CUSTOMFUNCTION_PRE preStartMenu
  !insertmacro MUI_PAGE_STARTMENU Application $StartMenuFolder
  
  ;Source code scripting removed

  !insertmacro MUI_PAGE_INSTFILES

  !define MUI_FINISHPAGE_RUN "$INSTDIR1\Civ4BeyondSword.exe"
    !define MUI_FINISHPAGE_RUN_PARAMETERS "$\"mod=\${MOD_LOC}$\""
    !define MUI_FINISHPAGE_RUN_NOTCHECKED
  !insertmacro MUI_PAGE_FINISH

  ;UN INSTALLER PAGES:

  !insertmacro MUI_UNPAGE_WELCOME
  !insertmacro MUI_UNPAGE_INSTFILES
  !insertmacro MUI_UNPAGE_FINISH

;--------------------------------
  ;Languages (Currently the installer is only in English)

  !insertmacro MUI_LANGUAGE "English"

  LangString DESC_Section1 ${LANG_ENGLISH} "Installs ${NAME} for ${BTS}."
  LangString DESC_Section4 ${LANG_ENGLISH} "Start Menu Shortcut Setup"
  LangString DESC_Section5 ${LANG_ENGLISH} "Creates a shortcut on the Desktop, allowing you to launch the mod \
                                            without the need to load ${BTS_SHORT} first."
  LangString DESC_Section6 ${LANG_ENGLISH} "Creates a shortcut on the Quick Launch bar, allowing you to launch \
                                            the mod directly from the task bar."

;--------------------------------
  ;Installer Sections	

  ;the mod files itself:
  Section /o "${MOD_LOC}" Section1
    SectionIn RO
    SetOutPath "$INSTDIR1\Mods\${MOD_LOC}"
    File /r "${MYCLSDIR}\*.*"
	WriteINIStr "$INSTDIR1\Mods\${MOD_LOC}\${SHORT_NAME} Info.url" "InternetShortcut" "URL" "${URL}"
      ; write uninstall information to the registry
    WriteRegStr ${MACHINE_REG_ROOT} "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MOD_LOC}" "DisplayName" "${NAME}"
    WriteRegStr ${MACHINE_REG_ROOT} "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MOD_LOC}" "UninstallString" "$INSTDIR1\Mods\${MOD_LOC}\Uninstall.exe"
    WriteRegStr ${MACHINE_REG_ROOT} "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MOD_LOC}" "ModInstDir" "$INSTDIR1\Mods\"
    WriteUninstaller "$INSTDIR1\Mods\${MOD_LOC}\Uninstall.exe"
	; Install UserSettings folder outside Program Files directory
	;SetOutPath "$CivRootDir\${MOD_LOC}"
	;File /r "${MYFILESDIR}\${MOD_LOC}\${SETTINGS_FOLDER}"
	;WriteRegStr ${USER_REG_ROOT} "Software\Microsoft\Windows\CurrentVersion\Uninstall\${SHORT_NAME}UserSettings" "UserSettings" "$CivRootDir\${MOD_LOC}"
  SectionEnd
  
  ;Start Menu stuff
  Section "Start Menu Shortcut" Section4
	!insertmacro MUI_STARTMENU_WRITE_BEGIN Application
	CreateDirectory "$SMPROGRAMS\$StartMenuFolder"
	CreateShortCut "$SMPROGRAMS\$StartMenuFolder\${NAME}.lnk" "$INSTDIR1\Civ4BeyondSword.exe" "$\"mod=\${MOD_LOC}$\"" "$INSTDIR\Mods\${MOD_LOC}\${RAW_ICON}" 0
	WriteINIStr "$SMPROGRAMS\$StartMenuFolder\${SHORT_NAME} Info.url" "InternetShortcut" "URL" "${URL}"
	CreateShortCut "$SMPROGRAMS\$StartMenuFolder\Uninstall.lnk" "$INSTDIR1\Mods\${MOD_LOC}\Uninstall.exe"
	!insertmacro MUI_STARTMENU_WRITE_END
	WriteRegStr ${USER_REG_ROOT} "Software\Microsoft\Windows\CurrentVersion\Uninstall\${SHORT_NAME}StartMenu" "StartMenuFolder" "$SMPROGRAMS\$StartMenuFolder"
   SectionEnd

   ;Desktop shortcut
  Section "Desktop Shortcut" Section5
    CreateShortCut "$DESKTOP\${NAME}.lnk" "$INSTDIR1\Civ4BeyondSword.exe" "$\"mod=\${MOD_LOC}$\"" "$INSTDIR\Mods\${MOD_LOC}\${RAW_ICON}" 0
  SectionEnd

  ;Quick Launch shortcut
  Section "Quick Launch Shortcut" Section6
    CreateShortCut "$QUICKLAUNCH\${SHORT_NAME}.lnk" "$INSTDIR1\Civ4BeyondSword.exe" "$\"mod=\${MOD_LOC}$\"" "$INSTDIR\Mods\${MOD_LOC}\${RAW_ICON}" 0
  SectionEnd

  
  !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
    !insertmacro MUI_DESCRIPTION_TEXT ${Section1}  $(DESC_Section1)
    !insertmacro MUI_DESCRIPTION_TEXT ${Section4}  $(DESC_Section4)
    !insertmacro MUI_DESCRIPTION_TEXT ${Section5}  $(DESC_Section5)
    !insertmacro MUI_DESCRIPTION_TEXT ${Section6}  $(DESC_Section6)
  !insertmacro MUI_FUNCTION_DESCRIPTION_END

;--------------------------------
;Uninstaller Section
  
    ;Initialize the Uninstaller
  Function un.onInit

    ;get mod install path of from the registy
    ReadRegStr $0 ${LONG_HKLM} "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\${MOD_LOC}" "ModInstDir"
	ReadRegStr $R1 ${LONG_HKCU} "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\${SHORT_NAME}StartMenu" "StartMenuFolder"
	;ReadRegStr $R2 ${LONG_HKCU} "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\${SHORT_NAME}UserSettings" "UserSettings"
  FunctionEnd

  Section "-un.StartMenu" SecUnStartMenu

    ;Delete Start Menu Shortcut
    RMDir /r "$R1"
	RMDir "$R1"
  SectionEnd
  
 ; Section "-un.UserSettings" SecUnUserSettings
  
    ;Delete UserSettings
  ;  RMDir /r "$R2"
;	RMDir "$R2"
 ; SectionEnd
  
  Section "un.Core" SecUnCore

    ;Delete everything in the Mod folder
    RMDir /r "$0\${MOD_LOC}\*.*"
    ;Remove the installation directory
    RMDir "$0\${MOD_LOC}"
    ;Delete Desktop Shortcut
    Delete "$DESKTOP\${NAME}.lnk"
    ;Delete Quicklaunch Shortcut
    Delete "$QUICKLAUNCH\${SHORT_NAME}.lnk"
  SectionEnd

  ;Remove the Registry Keys
  Section "-un.Registry" SecUnRegistry

    DeleteRegKey ${LONG_HKLM} "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\${MOD_LOC}"
    DeleteRegKey ${LONG_HKCU} "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\${SHORT_NAME}StartMenu"
  ;  DeleteRegKey ${LONG_HKCU} "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\${SHORT_NAME}UserSettings"
  SectionEnd
  
  ;Delete yourself Uninstaller
  Section "-un.Uninstaller" SecUnUninstaller

	Delete "$0\${MOD_LOC}\Uninstall.exe"
  SectionEnd

;--------------------------------
;Installer Functions

  ;Don't launch the Start Menu Shortcut Setup if it's not selected
  Function preStartMenu

	${Unless} ${SectionIsSelected} ${Section4}
		Abort
	${EndUnless}
  FunctionEnd

  ;Lock the Mod install itself
  Function myOnGUIInit
    SectionGetFlags ${Section1} $0
    IntOp $R0 $0 | ${SF_SELECTED}
    SectionSetFlags ${Section1} $R0
  FunctionEnd

  ;Don't allow installation if the BtS.exe isn't found
  Function .onVerifyInstDir
    StrCmp $CurrentPage "DirectoryPage1" check1 valid
    check1:
      IfFileExists "$INSTDIR1\${CIV_EXE_FILE}" valid invalid
    valid:
      Return
    invalid:
      Abort
  FunctionEnd

  ;Organize the Initialization, and setup what to do if the Civilization Registry is or isn't found
  Function onInitDirectoryPage1
	
	StrCpy $CurrentPage "DirectoryPage1"
    ;Section 1 selected?
    SectionGetFlags ${Section1} $0
    IntOp $R0 $0 & ${SF_SELECTED}
    IntCmp $R0 ${SF_SELECTED} checkRegEntry
      Abort ;skip page
    checkRegEntry:
      StrCmp $INSTDIR "" 0 checkDefaultLocation
        StrCpy $INSTDIR1 "" ;we know nothing
        Return
      checkDefaultLocation:
          StrCpy $INSTDIR1 "$INSTDIR" ;found it!
  FunctionEnd

  ;Rocking Code
  Function StartMenuShortcut
  
    Abort
  FunctionEnd
